#ifndef __PARAM_HPP__
#define __PARAM_HPP__

#define MAX_BLOCKS 128
#define MAX_LINES 256
#define MAX_PATH 128
#define MAX_CELLS 16384 // 128x128
#define MAX_SIZE 128
#define SLOT_MAX_SIZE 64


#define ROUND_LIMIT 4096 //32768 // Max=65534(=2^16-2)
//#define PRINT_BOARD
//#define PRINT_SEARCH // for router debug

#define PQ_BIT     16
#define MAX_PQ  65536

#define PRIO_BIT   16
#define DATA_BIT   16
#define ELEM_BIT   32 // ELEM_BIT = PRIO_BIT + DATA_BIT

#define DATA_MASK  65535 // 0000 FFFF
#define DATA_MAX   65535 // FFFF
#define PRIO_MAX   65535 // FFFF

#define LE 1
#define TO 2
#define RI 3
#define BO 4

#define SA_O   100
#define SA_I   100000
#define TEMP_S 500
#define TEMP_E 0.1

#define INTER_BLOCK_MARGIN 2

#define LOOP 50
#define TRY_LIMIT 500
#define NO_MOVE 10

#define LFSR_RAND_MAX 4294967295

#endif /* __PARAM_HPP__ */
